Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.quartz.impl
Class JobExecutionContextImpl

    java.lang.Object
      org.quartz.impl.JobExecutionContextImpl

All Implemented Interfaces:
  Serializable, JobExecutionContext

    public class JobExecutionContextImpl

extends Object
implements Serializable, JobExecutionContext

See Also:
  Serialized Form

Constructor Summary
`JobExecutionContextImpl(Scheduler scheduler, TriggerFiredBundle firedBundle, Job job)` Create a JobExcecutionContext with the given context data.

Method Summary
`Object` | `get(Object key)` Get the value with the given key from the context's data map.
`Calendar` | `getCalendar()` Get a handle to the `Calendar` referenced by the `Trigger` instance that fired the `Job`.
`String` | `getFireInstanceId()` Get the unique Id that identifies this particular firing instance of the trigger that triggered this job execution.
`Date` | `getFireTime()` The actual time the trigger fired.
`JobDetail` | `getJobDetail()` Get the `JobDetail` associated with the `Job`.
`Job` | `getJobInstance()` Get the instance of the `Job` that was created for this execution.
`long` | `getJobRunTime()` The amount of time the job ran for (in milliseconds).
`JobDataMap` | `getMergedJobDataMap()` Get the convenience `JobDataMap` of this execution context.
`Date` | `getNextFireTime()`
`Date` | `getPreviousFireTime()`
`TriggerKey` | `getRecoveringTriggerKey()` Return the `TriggerKey` of the originally scheduled and now recovering job.
`int` | `getRefireCount()`
`Object` | `getResult()` Returns the result (if any) that the `Job` set before its execution completed (the type of object set as the result is entirely up to the particular job).
`Date` | `getScheduledFireTime()` The scheduled time the trigger fired for.
`Scheduler` | `getScheduler()` Get a handle to the `Scheduler` instance that fired the `Job`.
`Trigger` | `getTrigger()` Get a handle to the `Trigger` instance that fired the `Job`.
`void` | `incrementRefireCount()`
`boolean` | `isRecovering()` If the `Job` is being re-executed because of a 'recovery' situation, this method will return `true`.
`void` | `put(Object key, Object value)` Put the specified value into the context's data map with the given key.
`void` | `setJobRunTime(long jobRunTime)`
`void` | `setResult(Object result)` Set the result (if any) of the `Job`'s execution (the type of object set as the result is entirely up to the particular job).
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JobExecutionContextImpl

    public JobExecutionContextImpl(Scheduler scheduler,
                                   TriggerFiredBundle firedBundle,
                                   Job job)

  Create a JobExcecutionContext with the given context data.

Method Detail

### getScheduler

    public Scheduler getScheduler()

  Get a handle to the `Scheduler` instance that fired the `Job`.

  Specified by:
    `getScheduler` in interface `JobExecutionContext`

### getTrigger

    public Trigger getTrigger()

  Get a handle to the `Trigger` instance that fired the `Job`.

  Specified by:
    `getTrigger` in interface `JobExecutionContext`

### getCalendar

    public Calendar getCalendar()

  Get a handle to the `Calendar` referenced by the `Trigger` instance that fired the `Job`.

  Specified by:
    `getCalendar` in interface `JobExecutionContext`

### isRecovering

    public boolean isRecovering()

  If the `Job` is being re-executed because of a 'recovery' situation, this method will return `true`.

  Specified by:
    `isRecovering` in interface `JobExecutionContext`

### getRecoveringTriggerKey

    public TriggerKey getRecoveringTriggerKey()

  Description copied from interface: `JobExecutionContext`
  Return the `TriggerKey` of the originally scheduled and now recovering job.

  When recovering a previously failed job execution this method returns the identity of the originally firing trigger. This recovering job will have been scheduled for the same firing time as the original job, and so is available via the `JobExecutionContext.getScheduledFireTime()` method. The original firing time of the job can be accessed via the `Scheduler.FAILED_JOB_ORIGINAL_TRIGGER_FIRETIME_IN_MILLISECONDS` element of this job's `JobDataMap`.

  Specified by:
    `getRecoveringTriggerKey` in interface `JobExecutionContext`
  Returns:
    the recovering trigger details

### incrementRefireCount

    public void incrementRefireCount()

### getRefireCount

    public int getRefireCount()

  Specified by:
    `getRefireCount` in interface `JobExecutionContext`

### getMergedJobDataMap

    public JobDataMap getMergedJobDataMap()

  Get the convenience `JobDataMap` of this execution context.

  The `JobDataMap` found on this object serves as a convenience - it is a merge of the `JobDataMap` found on the `JobDetail` and the one found on the `Trigger`, with the value in the latter overriding any same-named values in the former. It is thus considered a 'best practice' that the execute code of a Job retrieve data from the JobDataMap found on this object.

  NOTE: Do not expect value 'set' into this JobDataMap to somehow be set or persisted back onto a job's own JobDataMap - even if it has the `@PersistJobDataAfterExecution` annotation.

  Attempts to change the contents of this map typically result in an `IllegalStateException`.

  Specified by:
    `getMergedJobDataMap` in interface `JobExecutionContext`

### getJobDetail

    public JobDetail getJobDetail()

  Get the `JobDetail` associated with the `Job`.

  Specified by:
    `getJobDetail` in interface `JobExecutionContext`

### getJobInstance

    public Job getJobInstance()

  Get the instance of the `Job` that was created for this execution.

  Note: The Job instance is not available through remote scheduler interfaces.

  Specified by:
    `getJobInstance` in interface `JobExecutionContext`

### getFireTime

    public Date getFireTime()

  The actual time the trigger fired. For instance the scheduled time may have been 10:00:00 but the actual fire time may have been 10:00:03 if the scheduler was too busy.

  Specified by:
    `getFireTime` in interface `JobExecutionContext`
  Returns:
    Returns the fireTime.
  See Also:
    `JobExecutionContext.getScheduledFireTime()`

### getScheduledFireTime

    public Date getScheduledFireTime()

  The scheduled time the trigger fired for. For instance the scheduled time may have been 10:00:00 but the actual fire time may have been 10:00:03 if the scheduler was too busy.

  Specified by:
    `getScheduledFireTime` in interface `JobExecutionContext`
  Returns:
    Returns the scheduledFireTime.
  See Also:
    `JobExecutionContext.getFireTime()`

### getPreviousFireTime

    public Date getPreviousFireTime()

  Specified by:
    `getPreviousFireTime` in interface `JobExecutionContext`

### getNextFireTime

    public Date getNextFireTime()

  Specified by:
    `getNextFireTime` in interface `JobExecutionContext`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getResult

    public Object getResult()

  Returns the result (if any) that the `Job` set before its execution completed (the type of object set as the result is entirely up to the particular job).

  The result itself is meaningless to Quartz, but may be informative to ``JobListener`s` or ``TriggerListener`s` that are watching the job's execution.

  Specified by:
    `getResult` in interface `JobExecutionContext`
  Returns:
    Returns the result.

### setResult

    public void setResult(Object result)

  Set the result (if any) of the `Job`'s execution (the type of object set as the result is entirely up to the particular job).

  The result itself is meaningless to Quartz, but may be informative to ``JobListener`s` or ``TriggerListener`s` that are watching the job's execution.

  Specified by:
    `setResult` in interface `JobExecutionContext`

### getJobRunTime

    public long getJobRunTime()

  The amount of time the job ran for (in milliseconds). The returned value will be -1 until the job has actually completed (or thrown an exception), and is therefore generally only useful to `JobListener`s and `TriggerListener`s.

  Specified by:
    `getJobRunTime` in interface `JobExecutionContext`
  Returns:
    Returns the jobRunTime.

### setJobRunTime

    public void setJobRunTime(long jobRunTime)

  Parameters:
    `jobRunTime` - The jobRunTime to set.

### put

    public void put(Object key,
                    Object value)

  Put the specified value into the context's data map with the given key. Possibly useful for sharing data between listeners and jobs.

  NOTE: this data is volatile - it is lost after the job execution completes, and all TriggerListeners and JobListeners have been notified.

  Specified by:
    `put` in interface `JobExecutionContext`
  Parameters:
    `key` - the key for the associated value
    `value` - the value to store

### get

    public Object get(Object key)

  Get the value with the given key from the context's data map.

  Specified by:
    `get` in interface `JobExecutionContext`
  Parameters:
    `key` - the key for the desired value

### getFireInstanceId

    public String getFireInstanceId()

  Get the unique Id that identifies this particular firing instance of the trigger that triggered this job execution. It is unique to this JobExecutionContext instance as well.

  Specified by:
    `getFireInstanceId` in interface `JobExecutionContext`
  Returns:
    the unique fire instance id
  See Also:
    `Scheduler.interrupt(String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001-2013, Terracotta, Inc.